import { isShadowRoot } from "./aria.mjs";
import { isNumber, isStringNumber } from "../types.mjs";
import { isString, camelize, isObject } from "../../../../@vue/shared/dist/shared.esm-bundler.mjs";
import { entriesOf } from "../objects.mjs";
import { debugWarn } from "../error.mjs";
import { isClient } from "../../../node_modules/@vueuse/shared/index.mjs";
const SCOPE = "utils/dom/style";
const classNameToArray = (cls = "") => cls.split(" ").filter((item) => !!item.trim());
const hasClass = (el, cls) => {
  if (!el || !cls) return false;
  if (cls.includes(" ")) throw new Error("className should not contain space.");
  return el.classList.contains(cls);
};
const addClass = (el, cls) => {
  if (!el || !cls.trim()) return;
  el.classList.add(...classNameToArray(cls));
};
const removeClass = (el, cls) => {
  if (!el || !cls.trim()) return;
  el.classList.remove(...classNameToArray(cls));
};
const getStyle = (element, styleName) => {
  var _a;
  if (!isClient || !element || !styleName || isShadowRoot(element)) return "";
  let key = camelize(styleName);
  if (key === "float") key = "cssFloat";
  try {
    const style = element.style[key];
    if (style) return style;
    const computed = (_a = document.defaultView) == null ? void 0 : _a.getComputedStyle(element, "");
    return computed ? computed[key] : "";
  } catch {
    return element.style[key];
  }
};
const setStyle = (element, styleName, value) => {
  if (!element || !styleName) return;
  if (isObject(styleName)) entriesOf(styleName).forEach(([prop, value2]) => setStyle(element, prop, value2));
  else {
    const key = camelize(styleName);
    element.style[key] = value;
  }
};
function addUnit(value, defaultUnit = "px") {
  if (!value && value !== 0) return "";
  if (isNumber(value) || isStringNumber(value)) return `${value}${defaultUnit}`;
  else if (isString(value)) return value;
  debugWarn(SCOPE, "binding value must be a string or number");
}
export {
  addClass,
  addUnit,
  classNameToArray,
  getStyle,
  hasClass,
  removeClass,
  setStyle
};
